Bug 1571742 - Review Request: js-viewport-navigation - Scrolling viewport contents navigation menu for web pages
Summary: Review Request: js-viewport-navigation - Scrolling viewport contents navigati...
Keywords:
Status: CLOSED DEFERRED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR
TreeView+ depends on / blocked
 
Reported: 2018-04-25 10:48 UTC by Daniel J. R. May
Modified: 2018-06-01 12:09 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-06-01 12:09:25 UTC
Type: ---


Attachments (Terms of Use)

Description Daniel J. R. May 2018-04-25 10:48:53 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/danieljrmay/viewport-navigation/fedora-27-x86_64/00745027-js-viewport-navigation/js-viewport-navigation.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/danieljrmay/viewport-navigation/fedora-27-x86_64/00745027-js-viewport-navigation/js-viewport-navigation-0.5-1.fc27.src.rpm

Description: A JavaScript enhanced contents navigation menu which allows you to
easily see where you are in a long HTML/XHTML document.

Fedora Account System Username: danieljrmay

koji scratch build for f27: http://koji.fedoraproject.org/koji/taskinfo?taskID=26542586


Hello

This is my first package, and I am seeking a sponsor.

I am the upstream maintainer for viewport-navigation which is hosted on GitHub:
https://github.com/danieljrmay/viewport-navigation

Comment 2 Per Bothner 2018-05-18 20:31:40 UTC
Some preliminary informal comments, based on just the GitHub project.
These are my personal opinions/suggestions as a Fedora user, not a Fedora packing expert.

* I think you need to make a case for why this should be in Fedora.  It would be helpful if you linked to some web-page that actually uses the library - i.e. some real-life non-trivial web-page (with non-trivial styling).  Perhaps documentation or the home page for some other Fedora package (or proposed package).

* How does your navigator deal with multiple pages?  It seems it can only be useful for navigating a single-page document.  This limits its usefulness.  For comparison, I wrote a side-bar navigator for Kawa that handles navigation both between and within pages.  For example try: https://www.gnu.org/software/kawa/Strings.html#Immutable-String-Constructors . It might be useful to combine your logic for watching scrolling into my side-bar navigator.

* Using the GPL license for a JavaScript library means (I believe) that all of the JavaScript on a web page has to be released under the GPL.  This may be a concern for some people, and limit take-up - and possibly its suitability for Fedora.

Comment 3 Per Bothner 2018-05-18 20:39:55 UTC
I noted a minor glitch: https://github.com/danieljrmay/viewport-navigation/issues/3

Comment 4 Per Bothner 2018-05-18 20:56:36 UTC
Bottom line: I don't think js-viewport-navigation by itself is suitable as a Fedora package.  However, I do have something related that I'd love someone to look at: Last year Mathieu Lirzin did a Google Summer of Code project (http://mathieu.lirzin.emi.u-bordeaux.fr/tags/texinfo/) to implement smart JavaScript navigation for GNU texinfo manuals.  Here is his interface for the previously-mentioned Kawa manual:  https://www.gnu.org/software/texinfo/gsoc-2017-js-example/kawa/Strings.html#Concatenation-and-replacing

I would love for someone to combine Mathieu's code with your scroll-watcher and turn it into a separate library suitable for "book-style" sites (both ones generated from texinfo and otherwise).  (Mathieu's code is GPLT, for what that is worth.)

Comment 5 Daniel J. R. May 2018-06-01 12:02:39 UTC
(In reply to Per Bothner from comment #2)
> Some preliminary informal comments, based on just the GitHub project.
> These are my personal opinions/suggestions as a Fedora user, not a Fedora
> packing expert.

First of all thank you so much for taking the time to look at this & sorry for taking so long to reply - I have been away for the last couple of weeks.
 
> * I think you need to make a case for why this should be in Fedora.  It
> would be helpful if you linked to some web-page that actually uses the
> library - i.e. some real-life non-trivial web-page (with non-trivial
> styling).  Perhaps documentation or the home page for some other Fedora
> package (or proposed package).

I think you are absolutely correct! As it stands this project shows a little promise but it is not mature enough yet. On reflection, my desire to submit it to Fedora must have been a flash of middle-aged over-exuberance! I'm rather glad to see that I'm still capable of a bit over-exuberance! ;-)

However, I think the correct thing to do is withdraw this Fedora submission and go again when/if the software is more mature, fully-featured, documented and with real-life non-trivial examples of use in the wild. It current existence on github and COPR are appropriate for now. 

> * How does your navigator deal with multiple pages?  It seems it can only be
> useful for navigating a single-page document.  This limits its usefulness. 
> For comparison, I wrote a side-bar navigator for Kawa that handles
> navigation both between and within pages.  For example try:
> https://www.gnu.org/software/kawa/Strings.html#Immutable-String-Constructors
> . It might be useful to combine your logic for watching scrolling into my
> side-bar navigator.

Correct. As it stands it is a one-page only thing. Thank you for the links I will have a look into your suggestion.

> * Using the GPL license for a JavaScript library means (I believe) that all
> of the JavaScript on a web page has to be released under the GPL.  This may
> be a concern for some people, and limit take-up - and possibly its
> suitability for Fedora.

I was unaware of this - a really good point!

Comment 6 Daniel J. R. May 2018-06-01 12:04:01 UTC
(In reply to Per Bothner from comment #3)
> I noted a minor glitch:
> https://github.com/danieljrmay/viewport-navigation/issues/3

Thank you for submitting the bug report. I'll have a look into this.

Comment 7 Daniel J. R. May 2018-06-01 12:05:01 UTC
(In reply to Per Bothner from comment #4)
> Bottom line: I don't think js-viewport-navigation by itself is suitable as a
> Fedora package.  However, I do have something related that I'd love someone
> to look at: Last year Mathieu Lirzin did a Google Summer of Code project
> (http://mathieu.lirzin.emi.u-bordeaux.fr/tags/texinfo/) to implement smart
> JavaScript navigation for GNU texinfo manuals.  Here is his interface for
> the previously-mentioned Kawa manual: 
> https://www.gnu.org/software/texinfo/gsoc-2017-js-example/kawa/Strings.
> html#Concatenation-and-replacing
> 
> I would love for someone to combine Mathieu's code with your scroll-watcher
> and turn it into a separate library suitable for "book-style" sites (both
> ones generated from texinfo and otherwise).  (Mathieu's code is GPLT, for
> what that is worth.)

Sounds interesting. I will have a look into this.

Comment 8 Daniel J. R. May 2018-06-01 12:09:25 UTC
Following the excellent points raised by Per Bothner I am marking this CLOSED-DEFERRED as js-viewport-navigation is not mature enough yet for inclusion in Fedora.


Note You need to log in before you can comment on or make changes to this bug.